use <Write.scad>;

$fn=100;


module joint(width=6.1,length=10){
	translate([-width/2,0])
		square([width,length]);
	rotate(45,[0,0,1])
		square(width*1.25, center=true);

}

module linear_joint(width=6.1,length=10,offset=0){
	translate([-width/2,0])
		square([width,length]);
	//rotate(45,[0,0,1])
		circle(length*0.6+offset, center=true);

}

module linear_joint_round_bad(width=6.1,length=20){
	factor=0.75;
	difference(){
		union(){
			translate([0,(length/2)*(1-factor)])
				circle(r=(length/2)*factor);
			translate([0,0])
				square([length,length/2]);
			translate([length/4*1.41,-length/2])
				square(length);
		}
		translate([length/2*1.41,-(length/2)*(1-factor)])
			circle(r=(length/2)*factor);
		translate([length/4*1.41,-length/2])
			square(length/2);
	}
}

module linear_joint_square_unfinished(width=6.1,length=20){
	thickness=0.3;
	difference(){
		square(length,center=true);
		translate([0,0])
			square([2*thickness*length,thickness*length]);
	}

}

module test_sample(size=40){
	difference(){
		square(size,center=true);
		translate([0,-size/2])
			joint();
		rotate(90,[0,0,1])
			translate([0,-size/2])
				joint();

		rotate(180,[0,0,1])
			translate([0,-size/2])
				joint();

		rotate(270,[0,0,1])
			translate([0,-size/2])
				joint();
	}
}

//difference(){
//	test_sample();
//	write2D("Test",center=true);
//}

//joint();


module bogen_90deg(r=160,thickness=20){
	intersection(){
		difference(){
			circle(r,center=true);
			circle(r-thickness,center=true);
			translate([0,r-thickness/2])
				rotate(-90,[0,0,1])
					joint();
		}
		square(r);
	}
	translate([r-thickness/2,-thickness/2])
	difference(){
		square(thickness,center=true);
		translate([-thickness/2,0])
			rotate(-90,[0,0,1])
				joint();
	}
}

module bogen_connector_90deg(r=220,thickness=20){
	intersection(){
		difference(){
			circle(r,center=true);
			circle(r-thickness,center=true);
		for ( i = [0,22.5,45,67.5])
			rotate(90+11.25+i,[0,0,1])
				translate([0,-r])
					joint();
		rotate(90,[0,0,1])
			translate([r-thickness/2,-thickness/2])
				linear_joint(offset=-0.4);
		}
		square(r);
	}
	translate([r-thickness/2,-thickness/2])
		linear_joint();
}

module kreis_top(r=80,thickness=20){
	difference(){
		circle(r,center=true);
		circle(r-thickness-5,center=true);
		for ( i = [0,45,90,135,180,225,270,315])
			rotate(i,[0,0,1])
				translate([0,-r])
					joint();
	}
}

module kreis_60(r=30){
	difference(){
		circle(r,center=true);
		for ( i = [0,60,120,180,240,300])
			rotate(i,[0,0,1])
				translate([0,-r])
					joint();
	}
}

module straight(l=400,thickness=20){

	difference(){
		square([l,thickness],center=true);
		translate([(l-thickness)/2,-thickness/2])
			joint();
		translate([-(l-thickness)/2,-thickness/2])
			joint();
	}

}


module zweiboegen(){
rotate(45,[0,0,1])
	bogen_90deg();
//translate([70,120]) // for 100
translate([120,220]) // for 100
	rotate(180+45,[0,0,1])
		bogen_90deg();
}

module zweiconnector(){
rotate(45,[0,0,1])
	bogen_connector_90deg();
//translate([70,120]) // for 100
translate([120,335]) // for 100
	rotate(180+45,[0,0,1])
		bogen_connector_90deg();
}

module test_linear_joint(offset=0.1){
	//positiv
	translate([0,20])
	union(){
		square(20);
		translate([10,-10])
			linear_joint();
	}
	//negativ
	translate([0,-22])
	difference(){
		square(20);
		translate([10,10])
			linear_joint(offset=-0.4);
	}
}

module glasses(){
	difference(){
		union(){
			translate([75,0])
				circle(80);
			translate([-75,0])
				circle(80);
		}
		*translate([75,0])
			circle(70);
		*translate([-75,0])
			circle(70);
	}
	*translate([40,-10])
		circle(20);
	*translate([-40,-10])
		circle(20);
	translate([160,0])
		difference(){
			square(20,center=true);
			translate([0,-10])
				joint();
		}
	translate([-160,0])
		difference(){
			square(20,center=true);
			translate([0,-10])
				joint();
/*
			rotate(-90,[0,0,1])
			translate([0,-15])
				joint();
*/
		}
}

module hand(){
	import("MinionHand2.dxf");
}

//kreis_top();

//zweiboegen();
//rotate(45,[0,0,1])
//	bogen_connector_90deg();

//zweiconnector();
//straight();
//linear_joint_round();
//test_linear_joint();

//bogen_connector_90deg();
//bogen_90deg();

//kreis_top(25,40);
//kreis_60(20);
//glasses();

//straight(l=300);
//hand();

joint();